//ACScript Library v1.57 build 42
//http://www.clarkzoo.org/asheronscall/acscript
//Built on Wed Sep 19 21:09:41 2001 Pacific Time

//GLOBAL VARIABLES

// Control debug output within the library. Set to true for on, false for off. It's off by default.
var acslDebug=false; 

// Version string so your scripts can enforce the 
// correct version of this library be run with them. 
// Meant to coincide with the version of ACScript that it
// ships with.
var acslVersion=1.57;
var acslBuild=42;

// The following lines sets a conditional compilation variable. It's not missing a semicolon, no semicolon goes there.
@if(@acsl != @acsl)
@set @acsl=true
@end

// Timing constants. 
var acslPauseMS=250;  // used in fPause
var acslClientPause=100; // Experimental - for use in places that need only minimal client-side pauses
var acslServerPause=1000; // used in fPauseServer

// Smart mode 
var acslSmartMode=false; // used in experimental code designed to make scripts lag resistant.

// Standing or not
var acsl_standup_state=true;  // You enter the game standing up. Calling fLieDown() or fStandUp alters this variable.

// Return Values: Functions should return these as appropriate instead of numbers. 
var ciErrorSuccess=0;
var ciErrorRange=1;
var ciErrorNoConnection=750003;

// Merchant globals
var ciMerchantItemsTab=1;
var ciMerchantBuyingTab=2;
var ciMerchantSellingTab=3;

// "Goto" function globals
var ciMouseButton_Left = 0;
var ciMouseButton_Right = 1;
var ciMouseButton_Middle=2;
var ciBracelet_Left = 0;
var ciBracelet_Right = 1;
var ciRing_Left = 0;
var ciRing_Right = 1;

// timing globals
var mySleepTime=0;

//Spellcasting Globals
var ciWandHasSpell=true; // set to false if your character wields a wand that doesn't have spells.
var ciSpellErrSuccess	=0;
var ciSpellErrNotFound         = -1;
var ciSpellErrNoSkill          = -2;
var ciSpellErrTimeout          = -3;
var ciSpellErrSuccess          = 0;
var ciSpellErrTooBusy	= 29;
var ciSpellErrNoComponents     = 1024;
var ciSpellErrInsufficientMana = 1025;
var ciSpellErrFizzle           = 1026;
var ciSpellErrNotPK            = 1028;
// Constants used by the debugging functions

//	flag for initialized or not.
var ciDebugInitialized = 1;
var ciDebugUnInitialized = 0;

//	debugging level
var ciDbgMinimal = 0x1;
var ciDbgTrace = 0x2;
var ciDbgVars = 0x4;
var ciDbgDebug = 0x8;

//	debugging output - how much of it to make
var ciDebugLocDebugTerm = 0x1;
var ciDebugLocStdOut = 0x2;
var ciDebugLocFile = 0x4;
var ciDebugUseTimeStamp = 0x8;
var ciDebugOutAll = ciDebugLocDebugTerm | ciDebugLocStdOut | ciDebugLocFile | ciDebugUseTimeStamp;
var ciDebugFileStamp = ciDebugLocFile | ciDebugUseTimeStamp;

//	debugging output file name 
var csDebugFileLoc = "acsdebug.log";


//	Error Constants
var ciDbgErr_Success = 0;
var ciDbgErr_BitMaskNotANumber = 750001;
var ciDbgErr_FileNotInitialized = 750002;

//Private Vars
var prviDbgBitFlags = 0x0;
var prviDebugOut = 0x3;
var prvoFileSystem;
var prvoLogOut;
var prviDebugLogInitialized = 0;
var prvsDebugFileLoc=csDebugFileLoc;

// end of debug.js additions

// Globals for the spell creation functions
var    g_compsScroll = 0;           // How far down the comps list is scrolled.

// Spam Filter
var acslLastSayTime=new Date(); // stores the last time fSay was called, used to prevent your character being muted for spamming.
var acslMinQuietTime=2000; // the default minimum time your script must wait between calling fSay is two seconds (2000ms)
// Globals for the .WaitEvent method.

// Parameter Globals 

// tells ac.WaitEvent to wait for one event and then return
var ciWaitModeOne=1; 

// tells ac.WaitEvent to wait for a SPECIFIC event and then return 
// Use the event globals listed below to specify which event
var ciWaitModeSpecific=2; 

// tells ac.WaitEvent to wait for a certain amount of time (specified in the next parameter) 
// before returning.
var ciWaitModeUntilTimeout=3; 

// INC_OBJECT_* Flags
var ciCollectionAll = 0xffffffff;
var ciCollectionPlayers = 0x01;
var ciCollectionMonster = 0x02;
var ciCollectionPlayerCorpse = 0x04;
var ciCollectionMonsterCorpse = 0x08;
var ciCollectionLifestone = 0x10;
var ciCollectionPortal = 0x20;
var ciCollectionMerchant = 0x40;
var ciCollectionEquipment = 0x80;

// Event Globals
var ciOnVitals= 1; // refers to the ACMsg_OnVitals event
var ciOnLocChangeSelf= 2; // refers to the ACMsg_OnLocChangeSelf event
var ciOnLocChangeOther= 3; // refers to the ACMsg_OnLocChangeOther event
var ciOnStatTotalBurden= 4; // refers to the ACMsg_OnStatTotalBurden event
var ciOnStatTotalExp= 5; // refers to the ACMsg_OnStatTotalExp event
var ciOnStatUnspentExp= 6; // refers to the ACMsg_OnStatUnspentExp event
var ciOnObjectCreatePlayer= 7; // refers to the ACMsg_OnObjectCreatePlayer event
var ciOnStatSkillExp= 8; // refers to the ACMsg_OnStatSkillExp event
var ciOnAdjustStack= 9; // refers to the ACMsg_OnAdjustStack event
var ciOnChatLocal= 10; // refers to the ACMsg_OnChatLocal event
var ciOnChatSpell= 11; // refers to the ACMsg_OnChatSpell event
var ciOnDeathSelf= 12; // refers to the ACMsg_OnDeathSelf event
var ciOnMyPlayerKill= 13; // refers to the ACMsg_OnMyPlayerKill event
var ciOnDeathOther= 14; // refers to the ACMsg_OnDeathOther event
var ciOnEnd3D= 15; // refers to the ACMsg_OnEnd3D event
var ciOnStart3D= 16; // refers to the ACMsg_OnStart3D event
var ciOnStartPortalSelf= 17; // refers to the ACMsg_OnStartPortalSelf event
var ciOnEndPortalSelf= 18; // refers to the ACMsg_OnEndPortalSelf event
var ciOnEndPortalOther= 19; // refers to the ACMsg_OnEndPortalOther event
var ciOnCombatMode= 20; // refers to the ACMsg_OnCombatMode event
var ciOnAnimationSelf= 21; // refers to the ACMsg_OnAnimationSelf event
var ciOnTargetHealth= 22; // refers to the ACMsg_OnTargetHealth event
var ciOnAddToPack= 23; // refers to the ACMsg_OnAddToPack event
var ciOnRemoveFromInventory= 24; // refers to the ACMsg_OnRemoveFromInventory event
var ciOnAssessCreature= 25; // refers to the ACMsg_OnAssessCreature event
var ciOnAssessItem= 26; // refers to the ACMsg_OnAssessItem event
var ciOnSpellFailSelf= 27; // refers to the ACMsg_OnSpellFailSelf event
var ciOnMeleeEvadeSelf= 28; // refers to the ACMsg_OnMeleeEvadeSelf event
var ciOnMeleeEvadeOther= 29; // refers to the ACMsg_OnMeleeEvadeOther event
var ciOnMeleeDamageSelf= 30; // refers to the ACMsg_OnMeleeDamageSelf event
var ciOnMeleeDamageOther= 31; // refers to the ACMsg_OnMeleeDamageOther event
var ciOnLogon= 32; // refers to the ACMsg_OnLogon event
var ciOnTellServer= 33; // refers to the ACMsg_OnTellServer event
var ciOnTell= 34; // refers to the ACMsg_OnTell event
var ciOnTellMelee= 35; // refers to the ACMsg_OnTellMelee event
var ciOnTellMisc= 36; // refers to the ACMsg_OnTellMisc event
var ciOnTellFellowship= 37; // refers to the ACMsg_OnTellFellowship event
var ciOnTellPatron= 38; // refers to the ACMsg_OnTellPatron event
var ciOnTellVassal= 39; // refers to the ACMsg_OnTellVassal event
var ciOnTellFollower= 40; // refers to the ACMsg_OnTellFollower event
var ciOnDeathMessage= 41; // refers to the ACMsg_OnDeathMessage event
var ciOnSpellCastSelf=42; // refers to the ACMsg_OnSpellCastSelf event
var ciOnTradeStart=43; // refers to the ACMsg_OnTradeStart event
var ciOnTradeEnd=44; // refers to the ACMsg_OnTradeEnd event
var ciOnTradeAdd=45; // refers to the ACMsg_OnTradeAdd event
var ciOnTradeReset=46; // refers to the ACMsg_OnTradeReset event
var ciOnSetFlagSelf=47; // refers to the ACMsg_OnSetFlagSelf event
var ciOnSetFlagOther=48; // refers to the ACMsg_OnSetFlagOther event
var ciOnApproachVendor=49; // refers to the ACMsg_OnApproachVendor event
var ciOnChatBroadcast=50; // refers to the ACMsg_OnChatBroadcast event
var ciOnTradeAccept=51; // refers to the ACMsg_OnTradeAccept event
var ciOnObjectCreate=52; // refers to the ACMsg_OnObjectCreate event
var ciOnChatServer=53;// refers to the ACMsg_OnChatServer event
var ciOnSpellExpire=54; // refers to the ACMsg_OnSpellExpire event
var ciOnSpellExpireSilent=55;// refers to the ACMsg_OnSpellExpireSilent event
var ciOnStatTotalPyreals=56; // refers to the ACMsg_OnStatTotalPyreals event
var ciOnStatLevel=57; // refers to the ACMsg_OnStatLevel event
var ciOnChatEmoteStandard=58; // refers to the ACMsg_OnChatEmoteStandard event 
var ciOnChatEmoteCustom=59;// refers to the  ACMsg_OnChatEmoteCustom event
var ciOnOpenContainer=60;// refers to the ACMsg_OnOpenContainer event
var ciOnPortalStormWarning=61; // refers to the ACMsg_OnPortalStormWarning event
var ciOnPortalStormed=62; //refers to the ACMsg_OnPortalStormed event

// Keyboard globals
var g_kb_ClosestCompassItem="{BACK}";
var g_kb_Jump="{SPACE}";
var g_kb_IncreasePowerSetting="{PGUP}";
var g_kb_HighAttack="{PGDN}";
var g_kb_MediumAttack="{END}";
var g_kb_LastAttacker="{HOME}";
var g_kb_TurnLeft="{LEFT}";
var g_kb_WalkForward="{UP}";
var g_kb_TurnRight="{RIGHT}";
var g_kb_WalkBackwards="{DOWN}";
var g_kb_MapView="{ENTER}";
var g_kb_DecreasePowerSetting="{INS}";
var g_kb_LowAttack="{DEL}";
//var g_kb_TurnLeft="a"; // redundant
var g_kb_Sleeping="b";
var g_kb_SideStepRight="c";
//var g_kb_TurnRight="d"; // redundant
var g_kb_ExamineSelected="e";
var g_kb_AutosortSelected="f";
var g_kb_Sitting="g";
var g_kb_Crouch="h";
var g_kb_Laugh="i";
var g_kb_Wave="j";
var g_kb_PointState="k";
var g_kb_PreviousMonster="l";
var g_kb_NextFellow="m";
var g_kb_PreviousFellow="n";
var g_kb_Cheer="o";
var g_kb_PreviousSelection="p";
var g_kb_AutoRun="q";
var g_kb_UseSelected="r";
var g_kb_Ready="s";
var g_kb_SplitSelected="t";
var g_kb_Cry="u";
var g_kb_DropSelected="v";
var g_kb_WalkForward="w";
var g_kb_WalkBackwards="x";
var g_kb_Ready="y";
var g_kb_SideStepLeft="z";
var g_kb_ResetView="{NUM0}";
var g_kb_CameraLower="{NUM2}";
var g_kb_CameraLeftRotate="{NUM4}";
var g_kb_FloorView="{NUM5}";
var g_kb_CameraRightRotate="{NUM6}";
var g_kb_CameraRaise="{NUM8}";
var g_kb_CaptureScreenshotToFile="{KEYPAD *}";
var g_kb_CameraFarther="{KEYPAD +}";
var g_kb_CameraCloser="{KEYPAD -}";
var g_kb_FirstPersonView=".";
var g_kb_ShiftView="/";
var g_kb_CaptureScreenshotToFile="{F2}";
var g_kb_AllegiancePanel="{F3}";
var g_kb_FellowshipPanel="{F4}";
var g_kb_SpellbookPanel="{F5}";
var g_kb_SpellComponentsPanel="{F6}";
var g_kb_SpellResearchPanel="{F7}";
var g_kb_AttributesPanel="{F8}";
var g_kb_SkillsPanel="{F9}";
var g_kb_MapPanel="{F10}";
var g_kb_OptionsPanel="{F11}";
var g_kb_InventoryPanel="{F12}";
var g_kb_HoldRun="{SHIFT}";
var g_kb_HoldRun="{SHIFT}";
var g_kb_HoldSidestep="{ALT}";
var g_kb_HoldSidestep="{ALT}";
var g_kb_NextMonster=";";
var g_kb_NextCompassItem="=";
var g_kb_PreviousPlayer=",";
var g_kb_PreviousCompassItem="-";
var g_kb_NextPlayer=".";
var g_kb_ClosestPlayer="/";
var g_kb_ToggleCombat="`";
var g_kb_PreviousItem="[";
var g_kb_ClosestItem="\\";
var g_kb_NextItem="]";
var g_kb_ClosestMonster="'";


// BEGIN FUNCTIONS

//
//dec v1.0
//Parameters: Takes what you want converted from Hex as a parameter
//Return Value: Returns the decimal equivalent
//
function dec(a)
{
	return parseInt(a,16);
}

//
//fClick v1.0
//Parameters: null
//Return Value: null
//
function fClick()
{
	fScriptLibDebug("fClick called\n");
	ac.MouseClick(ciMouseButton_Left);
}

//
//fDoubleClick v1.0
//Parameters: null
//Return Value: null
//
function fDoubleClick()
{
	ac.MouseClick(ciMouseButton_Left);
	ac.MouseClick(ciMouseButton_Left);
	fPause();
}

//
//fMouseMoveTo v1.0
//Parameters: Takes X and Y coordinates as parameters valid ranges are 0-the max resolution currently running
//Return Value: null
//
function fMouseMoveTo(width,height)
{
	if(width<0 || width>Width) 
	{
		ac.Print("Error! fMouseMoveTo called with X=" + width + " but your max horizontal resolution being run is " + Width + "!\n");
		return ciErrorRange;
	}
	if(height<0 || height>Height) 
	{
		ac.Print("Error! fMouseMoveTo called with Y=" + height + " but your max vertical resolution being run is " + Height + "!\n");
		return ciErrorRange;
	}
	
	fScriptLibDebug("fMouseMoveTo placing mouse at " + width + "," + height + " using " + Width + "," + Height + ".\n");
	skapi.MouseMove(width,height);
}

//
//fRightClick v1.0
//Parameters: null
//Return Value: null
//
function fRightClick()
{
	fScriptLibDebug("fRightClick called\n");
	ac.MouseClick(ciMouseButton_Right);
}

//
//hex v1.0
//Parameters: Takes what you want converted Hexadecimal as a parameter
//Return Value: Returns the Hexadecimal value of the parameter you gave it
//
function hex(a)
{
	return a.toString(16);
}

//
//fGotoChatBar v1.0
//Parameters: null
//Return Value: null
//
function fGotoChatBar()
{
	fScriptLibDebug("fGotoChatBar called.\n");
	var myX=(Width-479);
	var myY=(Height-6);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSendButton v1.0
//Parameters: null
//Return Value: null
//
function fGotoSendButton()
{
	fScriptLibDebug("fGotoSendButton called.\n");
	var myX=(Width-334);
	var myY=(Height-6);
	fMouseMoveTo(myX,myY);
}

//
//fReply v1.1
//Parameters: thestring - the message to send
//Return Value: null
//
function fReply(thestring) 
{ 
    fScriptLibDebug("fReply called with " + thestring + " to say.\n"); 
    fSay("/reply " + thestring);     
}

//
//fSay v1.0
//Parameters: thestring - string value to speak
//Return Value: null
//
function fSay(thestring) 
{ 
	fScriptLibDebug("fSay called with " + thestring + " to say.\n"); 
	ac.KeyEvent("{RETURN}"); 
	fPause();
	ac.KeyPaste(thestring);	 
	fPause();
	ac.KeyEvent("{RETURN}"); 
}

//
//fTellFellows v1.1
//Parameters: thestring - string value to tell to those in your fellowship
//Return Value: null
//
function fTellFellows(thestring) 
{ 
    fScriptLibDebug("fTellFellows called with " + thestring + " to say.\n"); 
    fSay("/f "+thestring);     
}

//
//fTellPerson v1.1
//Parameters: person,thestring - who to tell and what message to send
//Return Value: null
//
function fTellPerson(person,thestring) 
{ 
    fScriptLibDebug("fTellPerson executing to tell " + person + "the message: " + thestring + "\n"); 
    fSay("/tell "+person+", "+thestring);     
}

//
//fDebugGetFlags v1.0
//Parameters: null
//Return Value: The current flags for debugging
//
function fDebugGetFlags()
{
	return prviDbgBitFlags;
}

//
//fDebugLogToFile v1.0
//Parameters: String to log to disk
//Return Value: null
//
function fDebugLogToFile(sText)
{
	if (fIsDebugInitialized() == ciDebugUnInitialized)
	{
		fInitializeDebugFile();
	}
	
	if ((sText.length > 1) && (sText.substr(sText.length - 1) == "\n"))
	{
		sText = sText.substr(0, sText.length - 1);
	}
	prvoLogOut.WriteLine(sText);
}

//
//fDebugOut v1.3
//Parameters: The string to output and the flags to use to output it with.
//Return Value: null
//
function fDebugOut(sText, iFlags)
{
	if (prviDbgBitFlags & ciDebugUseTimeStamp)
	{
		//Append a time stamp to the beginning
		var dDate = new Date();
		var sTmp;
		
		sTmp = "[" + dDate.getHours()
		sTmp = sTmp + ":" + dDate.getMinutes()
		sTmp = sTmp + ":" + dDate.getSeconds()
		sText = sTmp + "." + dDate.getMilliseconds() + "] " + sText;
	}
		
	if (iFlags | prviDbgBitFlags)
	{
		ac.Debug(sText);
	}

	if ((prviDebugOut & ciDebugLocFile) )//&& (iFlags & prviDbgBitFlags))
	{
		if(! prvsDebugFileLoc)
		{
			ac.Print("ERROR: fDebugOut called without calling fDebugSetLocation first!\n");
			ac.Beep(2);
			return ciDbgErr_FileNotInitialized;
		}
		fDebugLogToFile(sText)
	}
}

//
//fDebugSetFlags v1.0
//Parameters: Bit Mask to use to set how debugging is handled.
//Return Value: 0 on success or 750001 on failure
//
function fDebugSetFlags(iBitMask)
{
	if (!isNaN(iBitMask))
	{
		prviDbgBitFlags = iBitMask;
		return ciDbgErr_Success;
	}
	else
	{
		return ciDbgErr_BitMaskNotANumber;
	}
}

//
//fDebugSetLocation v1.0
//Parameters: Bit mask of values you want for your debug state, sFilepath is an optional parameter
//Return Value: null
//
function fDebugSetLocation(iBitMask, sFilepath)
{
	if (!isNaN(iBitMask))
	{
		prviDebugOut = iBitMask;
		
		if (typeof(sFilepath) != "undefined")
		{
			prvsDebugFileLoc = sFilepath;
		}
							
		return ciDbgErr_Success;
	}
	else
	{
		return ciDbgErr_BitMaskNotANumber;
	}
}

//
//fGetCallerName v1.0
//Parameters: Yourfunction.caller
//Return Value: Name of the function extracted from what was passed.
//
function fGetCallerName(Caller)
{
	fScriptLibDebug("fGetCallerName was called.\n");
	var src=Caller.toString();
	var re=/^function (.*)\(/; 
	var aArray=re.exec(src);
	if(aArray[1]==null) // when a function is called by 'main' the .Caller property is null. 
	{
		aArray[1]="main";
	}
	return aArray[1];
}

//
//fGetDebugFileName v1.0
//Parameters: null
//Return Value: Retuns the name of the file currently used for logging debug output.
//
function fGetDebugFileName()
{
	return prvsDebugFileLoc;
}

//
//fInitializeDebugFile v1.0
//Parameters: null
//Return Value: null
//
function fInitializeDebugFile()
{
	prvoFileSystem = new ActiveXObject("Scripting.FileSystemObject");
	prvoLogOut = prvoFileSystem.CreateTextFile(fGetDebugFileName(), true);
	
	prvoLogOut.WriteLine("ACScript Debug Output");
	prvoLogOut.WriteLine("---------------------");
	
	prviDebugLogInitialized = ciDebugInitialized
}

//
//fIsDebugInitialized v1.0
//Parameters: null
//Return Value: Returns one of two constants denoting whether or not writing debugging output to a file has been initialized.
//
function fIsDebugInitialized()
{
	if (prviDebugLogInitialized == ciDebugInitialized)
	{
		return ciDebugInitialized;
	}
	else
	{
		return ciDebugUnInitialized;
	}
}

//
//fScriptLibDebug v1.1
//Parameters: String of text to send to debugging output. Optional: Debug output flag
//Return Value: null
//
function fScriptLibDebug(string,iFlags)
{
        if(acslDebug)
        {
		if(iFlags)
		{
			fDebugOut(string,iFlags);
		}
		else
		{
			fDebugOut(string,fDebugGetFlags());
		}
        }
}

//
//fCloseCorpse v1.0
//Parameters: null
//Return Value: null
//
function fCloseCorpse()
{
	fScriptLibDebug("fCloseCorpse called.\n");
	fGotoCloseCorpse();
	fClick();
	fServerPause();  
}

//
//fEnsureCombatMode v1.1
//Parameters: fInCombatMode - boolean, true or false
//Return Value: 0 for success, 1 for error
//
function fEnsureCombatMode(combatmode)
{
     for(var i=0; skapi.fCombatMode==combatmode || i<5 ;i++)
     {
          skapi.Keys(cmidToggleCombat);
          skapi.WaitEvent(2000,wemFullTimeout);
          if(combatmode==skapi.fCombatMode)
          {
               return true;
          }
     }
     return false;
}          

 
 
  

//
//fExaminePack v1.1
//Parameters: pack,howmany - which pack to examine and how many items to examine in that pack
//Return Value: null
//
function fExaminePack(pack,howmany)
{
	var currentslot = 1;
	var row;
	var col;

	// if no pack is provided, assume it's the backpack
	if (!pack)
	{
		pack = 1;
	}

	// If howmany isn't provided, determine a good default value.
	// The main pack has 102 slots while the remaining packs have 24.
	if (!howmany)
	{
		if (pack == 1)
		{
			howmany = 102;
		}
		else
		{
			howmany = 24;
		}
	}

	if(pack<1 || pack>8)
	{
		ac.Print("Error! fExaminePack called with pack" + pack + ", which is outside it's allowed range of 1-8.\n");
		return ciErrorRange;
	}

	fScriptLibDebug("fExaminePack called with these parameters: " + pack + ", " + howmany + "\n");

	// Open pack number if specified
	fOpenPack(pack);
	
	while (currentslot <= howmany)
	{
		fOpenInventory();
		col = 1 + (currentslot - 1) % 6;
		row = parseInt(1 + (currentslot - 1) / 6);
		if (row > 3) row = 3;
		fGotoPackSlot(col,row);
		fClick();
		fServerPause();  // This pause really helps to be sure to get a successful examination
		fExamine();
		if (row == 3 && col == 6 && currentslot != howmany)
		{
			fOpenInventory();
			fScrollPackDown();
		}
		currentslot++;
	}
}

//
//fGotoCastSpell v1.0
//Parameters: null
//Return Value: null
//
function fGotoCastSpell()
{
	fScriptLibDebug("fGotoCastSpell called\n");
	var myX = Width - 425;
	var myY = Height - 110;
	fMouseMoveTo(myX, myY);
}

//
//fGotoCloseAC v1.0
//Parameters: null
//Return Value: null
//
function fGotoCloseAC()
{
	fScriptLibDebug("fGotoCloseAC called\n");
	var myX = Width - 15;
	var myY = 15;
	fMouseMoveTo(myX, myY);
}

//
//fGotoCloseACConfirm v1.0
//Parameters: null
//Return Value: null
//
function fGotoCloseACConfirm()
{
	fScriptLibDebug("fGotoCloseACConfirm called.\n");
	var myX=(Width-220);
	var myY=(Height-123);
	fMouseMoveTo(myX,myY);
}

//
//fGotoCloseCorpse v1.0
//Parameters: null
//Return Value: null
//
function fGotoCloseCorpse()
{
	fScriptLibDebug("fGotoCloseCorpse called.\n");
	var myX=(Width-329);
	var myY=(Height-177);
	fMouseMoveTo(myX,myY);	
}

//
//fGotoCorpseSlot v1.0
//Parameters: Which corpse slot to go to, 1+
//Return Value: null
//
function fGotoCorpseSlot(which)
{
	if(which <1)
	{
		ac.Print("Error: fGotoCorpseSlot called with the parameter " + which + " which is outside the acceptable range of 1+\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoCorpseSlot called with " + which + " as a parameter.\n");
	which--; // accounts for 1 needing to not add anything to the coordinates.
	var myX=34 + (which * 32);
	var myY=(Height - 128);
	fMouseMoveTo(myX,myY);
}

//
//fGotoDisbandFellowship v1.0
//Parameters: null
//Return Value: null
//
function fGotoDisbandFellowship()
{
	fScriptLibDebug("fGotoDisbandFellowship called.\n");
	var myX=(Width-63);
	var myY=(Height-110);
	fMouseMoveTo(myX,myY);
}

//
//fGotoExamine v1.0
//Parameters: null
//Return Value: null
//
function fGotoExamine()
{
	fScriptLibDebug("fGotoExamine called\n");
	var myX = Width - 75;
	var myY = Height - 55;
	
	fMouseMoveTo(myX, myY);
}

//
//fGotoFellowshipCreate v1.0
//Parameters: null
//Return Value: null
//
function fGotoFellowshipCreate()
{
	fScriptLibDebug("fGotoFellowshipCreate called.\n");
	var myX=(Width-149);
	var myY=(Height-110);
	fMouseMoveTo(myX,myY);	
}

//
//fGotoFellowshipDismiss v1.0
//Parameters: null
//Return Value: null
//
function fGotoFellowshipDismiss()
{
	fScriptLibDebug("fGotoFellowshipDismiss called.\n");
	var myX=(Width-153);
	var myY=(Height-110);
	fMouseMoveTo(myX,myY);
}

//
//fGotoFellowshipName v1.0
//Parameters: null
//Return Value: null
//
function fGotoFellowshipName()
{
	fScriptLibDebug("fGotoFellowshipName called.\n");
	var myX=(Width-90);
	var myY=(Height-212);
	fMouseMoveTo(myX,myY);
}

//
//fGotoFellowshipRecruit v1.0
//Parameters: null
//Return Value: null
//
function fGotoFellowshipRecruit()
{
	fScriptLibDebug("fGotoFellowshipRecruit called.\n");
	var myX=(Width-243);
	var myY=(Height-110);
	fMouseMoveTo(myX,myY);
}

//
//fGotoInscription v1.0
//Parameters: null
//Return Value: null
//
function fGotoInscription()
{
	fScriptLibDebug("fGotoInscription called.\n");
	var myX=(Width-164);
	var myY=(Height-128);
	fMouseMoveTo(myX,myY);
}

//
//fGotoLowerChatWindow v1.0
//Parameters: null
//Return Value: null
//
function fGotoLowerChatWindow()
{
    fScriptLibDebug("fGotoLowerChatWindow called to lower chat window to a minimum.\n");
    var myX=(Width - 316);
    var myY=(Height - 325);
    fMouseMoveTo(myX,myY);
}

//
//fGotoMerchantBuySellAllButton v1.1
//Parameters: null
//Return Value: null
//
function fGotoMerchantBuySellAllButton()
{
	fScriptLibDebug("fGotoMerchantSellAllButton called.\n");
	var myX=(Width - 340);
	var myY=(Height - 140); 
	fMouseMoveTo(myX,myY);
}

//
//fGotoMerchantBuySellButton v1.0
//Parameters: null
//Return Value: null
//
function fGotoMerchantBuySellButton()
{
	fScriptLibDebug("fGotoMerchantSellButton called.\n");
	var myX=(Width - 340);
	var myY=(Height - 170);
	fMouseMoveTo(myX,myY);
}

//
//fGotoMerchantCloseWindow v1.0
//Parameters: null
//Return Value: null
//
function fGotoMerchantCloseWindow()
{
	fScriptLibDebug("fGotoMerchantCloseWindow called to go to the merchant close window control.\n");
	var myX=(Width-320);
	var myY=(Height - 190);
	fMouseMoveTo(myX,myY);
}

//
//fGotoMerchantScrollLeft v1.0
//Parameters: null
//Return Value: null
//
function fGotoMerchantScrollLeft()
{
	fScriptLibDebug("fGotoMerchantScrollLeft called.\n");
	var myX=(14);
	var myY=(Height-100);
	fMouseMoveTo(myX,myY);
}

//
//fGotoMerchantScrollRight v1.0
//Parameters: null
//Return Value: null
//
function fGotoMerchantScrollRight()
{
	fScriptLibDebug("fGotoMerchantScrollRight called.\n");
	var myX=(Width-386);
	var myY=(Height-115);
	fMouseMoveTo(myX,myY);
}

//
//fGotoMerchantScrollRightBar v1.0
//Parameters: null
//Return Value: null
//
function fGotoMerchantScrollRightBar()
{
	fScriptLibDebug("fGotoMerchantScrollRightBar called.\n");
	var myX=(Width-399);
	var myY=(Height-115);
	fMouseMoveTo(myX,myY);
}

//
//fGotoScrollCorpsePackLeft v1.0
//Parameters: null
//Return Value: null
//
function fGotoScrollCorpsePackLeft()
{
	fScriptLibDebug("fGotoScrollCorpsePackLeft called.\n");
	var myX=28;
	var myY=(Height-100);
	fMouseMoveTo(myX,myY);
}

//
//fGotoScrollCorpsePackRight v1.0
//Parameters: null
//Return Value: null
//
function fGotoScrollCorpsePackRight()
{
	fScriptLibDebug("fGotoScrollCorpsePackRight called.\n");
	var myX=(Width-344);
	var myY=(Height-100);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradeAccept v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradeAccept()
{
	fScriptLibDebug("fGotoSecureTradeAccept called.\n");
	var myX=((Width/2)-130); 
	var myY=(Height-185);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradeButton v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradeButton()
{
	fScriptLibDebug("fGotoSecureTradeButton called.\n");
	var myX=(Width-150);
	var myY=(Height-370);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradeCancel v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradeCancel()
{
	fScriptLibDebug("fGotoSecureTradeCancel called.\n");
	var myX=(Width-320);
	var myY=(Height-190);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradeClearAll v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradeClearAll()
{
	fScriptLibDebug("fGotoSecureTradeClearAll called.\n");
	var myX=((Width/2)-155); 
	var myY=(Height-152);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradeMyScrollLeft v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradeMyScrollLeft()
{
	fScriptLibDebug("fGotoSecureTradeMyScrollLeft called.\n");
	var myX=((Width/2)-145); 
	var myY=(Height-110);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradeMyScrollRight v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradeMyScrollRight()
{
	fScriptLibDebug("fGotoSecureTradeMyScrollRight called.\n");
	var myX=(Width-318); 
	var myY=(Height-103);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradeMySlot v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradeMySlot()
{
	fScriptLibDebug("fGotoSecureTradeMySlot called.\n");
	var myX=((Width/2)-140); 
	var myY=(Height-128);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradePartnerScrollLeft v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradePartnerScrollLeft()
{
	fScriptLibDebug("fGotoSecureTradePartnerScrollLeft called.\n");
	var myX=8; 
	var myY=(Height-100);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradePartnerScrollRight v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradePartnerScrollRight()
{
	fScriptLibDebug("fGotoSecureTradePartnerScrollRight called.\n");
	var myX=((Width/2)-165); 
	var myY=(Height-100);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradePartnerSlot v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradePartnerSlot()
{
	fScriptLibDebug("fGotoSecureTradePartnerSlot called.\n");
	var myX=14; 
	var myY=(Height-128);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSecureTradeTab v1.0
//Parameters: null
//Return Value: null
//
function fGotoSecureTradeTab()
{
	fScriptLibDebug("fGotoSecureTradeTab called.\n");
	var myX=(Width-70);
	var myY=(Height-437);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSocialTab v1.0
//Parameters: Which tab to go to (1-3)
//Return Value: null
//
function fGotoSocialTab(which) 
{
	fScriptLibDebug("fGotoSocialTab called with " + which + " as a parameter.\n");
	if(which >3 || which <1)
	{
		ac.Print("Error: fGotoSocialTab called with the parameter " + which + " which is out of the acceptable range of 1 and 3\n");
		return ciErrorRange;
	}
	which--; // This allows the math to work while still using 1-3 instead of 0-2.
	var myX=(Width-250)+(which*90); 
	var myY=(Height-437);
	fMouseMoveTo(myX,myY);
}

//
//fLogoutMouse v1.0
//Parameters: null
//Return Value: null
//
function fLogoutMouse()
{
	fScriptLibDebug("fLogoutMouse called\n");
	fGotoCloseAC(); 
	fClick();
	fServerPause(); 
	fGotoCloseACConfirm();
	fClick();
	fServerPause();
}

//
//fMiddleClick v1.0
//Parameters: null
//Return Value: null
//
function fMiddleClick()
{
	fScriptLibDebug("fMiddleClick called\n");
	ac.MouseClick(ciMouseButton_Middle);
}

//
//fOpenSocialPanel v1.1
//Parameters: null
//Return Value: null
//
function fOpenSocialPanel()
{
	fScriptLibDebug("fOpenSocialPanel called to open the allegiance/fellowship/secure trade window.\n");
	ac.KeyEvent(g_kb_SpellbookPanel); // opens this one first as 'bow dance'. 
	fPause();
	ac.KeyEvent(g_kb_FellowshipPanel);
}

//
//fTellCoVassals v1.0
//Parameters: String to send to your patron and co-vassals.
//Return Value: null
//
function fTellCoVassals(thestring) 
{ 
    fScriptLibDebug("fTellCoVassals executing to tell co-vassals the message: " + thestring + "\n"); 
    fSay("/c " + thestring);     
}

//
//fTellPatron v1.0
//Parameters: String to send to your patron
//Return Value: null
//
function fTellPatron(thestring) 
{ 
    fScriptLibDebug("fTellPatron executing to tell your patron the message: " + thestring + "\n"); 
    fSay("/p " + thestring);
}

//
//fTellVassals v1.0
//Parameters: Message to send to vassals
//Return Value: null
//
function fTellVassals(thestring) 
{ 
    fScriptLibDebug("fTellVassals executing to tell vassals the message: " + thestring + "\n"); 
    fSay("/v " + thestring);     
}

//
//fFindItem v1.1
//Parameters: name
//Return Value: -1 if not found, array (pack, slot) if found
//
function fFindItem(name)
{
	fScriptLibDebug("fFindItem being called with " + name + " as a parameter");
	
	if(name == 0) 
	{
		ac.Print("Error: fFindItem called without a parameter - call it with the name of the object to find.\n");
		return ciErrorRange;
	}

	var ConfirmACCom=ac.ConnectedToAC;
	if(! (ConfirmACCom & 0x8))
	{
		ac.Print("ACScriptLib.js/fFindItem Error:\nEither ACCom isn't loaded or you logged in before running this script,\nor for some other reason the ac.ConnectedToAC property didn't get populated.\n");
		fScriptLibDebug("Error: fFindItem couldn't detect a good connection via ACCom. ac.ConnectedToAC=" + ConfirmACCom + "\n");
		return ciErrorNoConnection;
	}
	
	var pack;
	var slot;

	for (pack = 0; pack < Inventory.NumberOfPacks; pack++)
	{
		for (slot = 0; slot < Inventory.ItemsInPack(pack); slot++)
		{
			id = Inventory.GetItem(pack, slot);
			var itemname = ac.ItemProperty(id, "name");

			if (ac.ItemProperty(id, "name") == name)
			{
				return new Array(pack, slot);
			}
		}
	}
	fScriptLibDebug("fFindItem returning -1: error object " + name + " not found.");
	return -1;
}

//
//fGotoAbdomen v1.0
//Parameters: null
//Return Value: null
//
function fGotoAbdomen()
{
	fScriptLibDebug("fGotoAbdomen called.\n");
	var myX=(Width-205);
	var myY=(Height-332);
	fMouseMoveTo(myX,myY);
}

//
//fGotoAmmo v1.0
//Parameters: null
//Return Value: null
//
function fGotoAmmo() 
{
	fScriptLibDebug("fGotoAmmo called.\n");
	var myX=(Width-110);
	var myY=(Height-234);
	fMouseMoveTo(myX,myY);
}

//
//fGotoBracelet v1.0
//Parameters: 0 or 1 - 0 is left bracelent, 1 is right bracelet.
//Return Value: null
//
function fGotoBracelet(which)
{
	if(which >1 || which <0)
	{
		ac.Print("Error: fGotoBracelet called with the parameter " + which + " which is out of the acceptable range of 0 and 1\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoBracelet called with " + which + " as a parameter.\n");
	var myX=(Width - 271) + (which * 145);
	var myY=(Height - 319);
	fMouseMoveTo(myX,myY);
}

//
//fGotoChest v1.0
//Parameters: null
//Return Value: null
//
function fGotoChest()
{
	fScriptLibDebug("fGotoChest called.\n");
	var myX=(Width-206);
	var myY=(Height-360);
	fMouseMoveTo(myX,myY);
}

//
//fGotoFeet v1.0
//Parameters: null
//Return Value: null
//
function fGotoFeet()
{
	fScriptLibDebug("fGotoFeet called.\n");
	var myX=(Width-181);
	var myY=(Height-220);
	fMouseMoveTo(myX,myY);
}

//
//fGotoHands v1.0
//Parameters: null
//Return Value: null
//
function fGotoHands()
{
	fScriptLibDebug("fGotoHands called.\n");
	var myX=(Width-163);
	var myY=(Height-315);
	fMouseMoveTo(myX,myY);
}

//
//fGotoHead v1.0
//Parameters: null
//Return Value: null
//
function fGotoHead()
{
	fScriptLibDebug("fGotoHead called.\n");
	var myX=(Width-203);
	var myY=(Height-419);
	fMouseMoveTo(myX,myY);
}

//
//fGotoLowerArms v1.0
//Parameters: null
//Return Value: null
//
function fGotoLowerArms()
{
	fScriptLibDebug("fGotoLowerArms called.\n");
	var myX=(Width-163);
	var myY=(Height-341);
	fMouseMoveTo(myX,myY);
}

//
//fGotoLowerLegs v1.0
//Parameters: null
//Return Value: null
//
function fGotoLowerLegs()
{
	fScriptLibDebug("fGotoLowerLegs called.\n");
	var myX=(Width-186);
	var myY=(Height-253);
	fMouseMoveTo(myX,myY);
}

//
//fGotoNecklace v1.0
//Parameters: null
//Return Value: null
//
function fGotoNecklace()
{
	fScriptLibDebug("fGotoNecklace called.\n");
	var myX=(Width-254);
	var myY=(Height-405);
	fMouseMoveTo(myX,myY);
}

//
//fGotoPack v1.0
//Parameters: takes a pack number, 1-8
//Return Value: null
//
function fGotoPack(which)
{
	if(!which)
	{
		which = 1;  // Default value
	}

	if(which<1 || which >8)
	{
		ac.Print("Error! fGotoPack called with " + which + ", which is outside it's allowed range of 1-8.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoPack called with " + which + " as the parameter.\n");
	which--; // this corrects for the formula I'm now using, where everything starts at 0.
	var myX=(Width - 38);
	var myY=((Height - 385 + ( which * 36)));
	fMouseMoveTo(myX,myY);
}

//
//fGotoPackSlot v1.2
//Parameters: Takes column (x, 1-6) and row (y,1-3) as parameters
//Return Value: null
//
function fGotoPackSlot(column,row)
{
	if(column < 1 || column >6)
	{
		ac.Print("Error! fGotoPackSlot called with column=" + column + ", which is outside the acceptable range of 1-6.\n");
		return ciErrorRange;
	}
	if(row < 1 || row >3)
	{
		ac.Print("Error! fGotoPackSlot called with row=" + row + ", which is outside the acceptable range of 1-3.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoPackSlot placing mouse at slot position " + column + "," + row + ".\n");

	column--; 
	row--; 
	var myX=(Width - 238 + (column * 32));
	var myY=(Height - 157 + (row * 32));
	skapi.MouseMove(myX,myY);
}

//
//fGotoPackSlotAbs v1.0
//Parameters: Which pack (1-8), which column (1-6), and which row (1 to either 17 for pack 1 or 4 for the others)
//Return Value: null
//
function fGotoPackSlotAbs(pack,column,row)
{
	var iMaxSlots; // holds the numberof slots in the pack - main pack (1) has 17.All others, 4, it's assumed.
	var iRowMod; // modifies the number of rows to go down, if needed. 
	
	if(pack==1) 
	{
		iMaxSlots=17;
	}
	else
	{
		iMaxSlots=4;
	}
	
	if(pack <1 || pack >8)
	{
		ac.Print("Error! fGotoPackSlotAbs called with pack=" + pack + ", which is outside the acceptable range of 1-8.\n");
		return ciErrorRange;
	}
	
	if(column < 1 || column >6)
	{
		ac.Print("Error! fGotoPackSlotAbs called with  column=" + column + ", which is outside the acceptable range of 1-6.\n");
		return ciErrorRange;
	}
	
	if(row < 1 || row > iMaxSlots)
	{
		ac.Print("Error! fGotoPackSlotAbs called with row=" + row + ", which is outside the acceptable range of 1-3.\n");
		return ciErrorRange;
	}
	
	fScriptLibDebug("fGotoPackSlotAbs called, placing mouse at pack " + pack + " at slot position" + column + "," + row + ".\n");
	
	fOpenPack(pack);
		
	// Scroll down the appropriate amount:
	if(row>3)
	{
		iRowMod=(row-3);
		fScrollPackDown(iRowMod);
	}
	else
	{
		iRowMod=0
	}
	
	var iRelativeRow=(row-iRowMod);

	fGotoPackSlot(column,iRelativeRow); 
}

//
//fGotoRing v1.0
//Parameters: 0 or 1 - 0 is left right, 1 is right ring.
//Return Value: null
//
function fGotoRing(which)
{
	if(which<0 || which >1)
	{
		ac.Print("Error: fGotoRing called with " + which + " which is outside the allowable range of 0 and 1.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoRing called with " + which + " as a parameter.\n");
	var myX=(Width-271) + (which *145);
	var myY=(Height - 285);
	fMouseMoveTo(myX,myY);
}

//
//fGotoScrollPackDown v1.0
//Parameters: null
//Return Value: null
//
function fGotoScrollPackDown()
{
	fScriptLibDebug("fGotoScrollPackDown called.\n");
	var myX=(Width-85);
	var myY=(Height-110);
	fMouseMoveTo(myX,myY);
}

//
//fGotoScrollPackUp v1.0
//Parameters: null
//Return Value: null
//
function fGotoScrollPackUp()
{
	fScriptLibDebug("fGotoScrollPackUp called.\n");
	var myX=(Width-85);
	var myY=(Height-184);
	fMouseMoveTo(myX,myY);
}

//
//fGotoShield v1.0
//Parameters: null
//Return Value: null
//
function fGotoShield()
{
	fScriptLibDebug("fGotoShield called.\n");
	var myX=(Width-270);
	var myY=(Height-234);
	fMouseMoveTo(myX,myY);
}

//
//fGotoShortcut v1.0
//Parameters: which - specify a shortcut between 1 and 9 inclusive
//Return Value: null
//
function fGotoShortcut(which)
{
	if(which<1 || which >9 )
	{
		ac.Print("Error! fGotoShortcut called with " + which + ", which is outside the acceptable range of 1-9.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoShortcut called to go to shortcut " + which + ".\n");
	which--;
	var myX=(Width - 285 + (which * 32));
	var myY=(Height - 15);
	fMouseMoveTo(myX,myY);
}

//
//fGotoUpperArms v1.0
//Parameters: null
//Return Value: null
//
function fGotoUpperArms()
{
	fScriptLibDebug("fGotoUpperArms called.\n");
	var myX=(Width-172);
	var myY=(Height-357);
	fMouseMoveTo(myX,myY);
}

//
//fGotoUpperLegs v1.0
//Parameters: null
//Return Value: null
//
function fGotoUpperLegs()
{
	fScriptLibDebug("fGotoUpperLegs called.\n");
	var myX=(Width-189);
	var myY=(Height-302);
	fMouseMoveTo(myX,myY);
}

//
//fGotoWeapon v1.0
//Parameters: null
//Return Value: null
//
function fGotoWeapon()
{
	fScriptLibDebug("fGotoWeapon called.\n");
	var myX=(Width-145);
	var myY=(Height-234);
	fMouseMoveTo(myX,myY);
}

//
//fMoveToPack v1.1
//Parameters: which pack
//Return Value: null
//
function fMoveToPack(which)
{
	if(which<1 || which >8) 
	{
		ac.Print("Error! fMoveToPack called with " + which + ", which is outside it's allowed range of 1-9.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fMoveToPack called with " + which + " as a parameter.\n\n");
	ac.MouseButtonPress(ciMouseButton_Left);
	fPause();
	fGotoPack(which);
	fPause();
	ac.MouseButtonRelease(ciMouseButton_Left);
	fServerPause();
}

//
//fOpenInventory v1.1
//Parameters: null
//Return Value: null
//
function fOpenInventory()
{
	fScriptLibDebug("fOpenInventory called.\n");
	ac.KeyEvent(g_kb_AttributesPanel); // bow dance
	ac.KeyEvent(g_kb_InventoryPanel); 
}

//
//fOpenPack v1.0
//Parameters: Which pack
//Return Value: null
//
function fOpenPack(iPack)
{
	if(!iPack)
	{
		iPack = 1;  //Default value
	}

	if(iPack<1 || iPack>8)
	{
		ac.Print("Error: fOpenPack called with " + iPack + " which is outside the allowable range of 1 and 8.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fOpenPack called with " + iPack + " as a parameter\n");
	
	// We want to open a specific pack, but what if the inventory isn't open? We better open it ourselves,
	//just to be sure.
	fOpenInventory();
	
	// The following is like doing the bow dance - ensures that we switch packs for sure, 
	//causes the pack we want to be open AND scrolled all the way up.
	var ModPack=(iPack-1);
	if(ModPack<1)
	{
		ModPack=2;
	}
	
	fGotoPack(ModPack);
	fPause();
	fClick(); 
	fPause();
	
	fGotoPack(iPack); 
	fPause();
	fClick();
	fPause();
}

//
//fPutInPack v1.0
//Parameters: which,howmany - which pack to put something in, and how many somethings to put there.
//Return Value: null
//
function fPutInPack(which,howmany)
{
	if(which <1 || which >8)
	{
		ac.Print("Error! fPutInPack called with pack=" + which + ", which is outside it's acceptable range of 1-8.\n");
		return ciErrorRange;
	}
	if(howmany <1)
	{
		ac.Print("Error! fPutInPack called with #=" + howmany + ", which must be >0.\n");
		return ciErrorRange;
	}
	
	fScriptLibDebug("fPutInPack executing putting " + howmany + " items into pack # " + which + ".\n");
	
	for(var loop=0;loop<howmany;loop++)
	{
		fGotoPackSlot(1,1);
		fPutXinPack(which);
	}
}

//
//fPutXinPack v1.0
//Parameters: Which pack you want : 1-8
//Return Value: null
//
function fPutXinPack(which)
{
	if(which<1 || which >8) 
	{
		ac.Print("Error! fPutXinPackcalled with " + which + ", which is outside it's allowed range of 1-9.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fPutXinPack called with " + which + " as a parameter.\n\n");
	ac.MouseButtonPress(ciMouseButton_Left);
	fPause();
	fGotoPack(which);
	fPause();
	ac.MouseButtonRelease(ciMouseButton_Left);
	fServerPause();
}

//
//fScrollPackDown v1.1
//Parameters: howmany - how many times to scroll the pack down - defaults to scrolling down once if no parameter specified.
//Return Value: null
//
function fScrollPackDown(howmany)
{
	if(!howmany)
	{
		howmany = 1; // Default - scroll down once.
	}
	if(howmany <1) 
	{
		ac.Print("Error! fScrollPackDown called with " + howmany + " as a parameter, which is not within it's acceptable range.\n");
		return ciErrorRange;
	}
	fOpenInventory();
	fScriptLibDebug("fScrollPackDown called to scroll pack down " + howmany + "times.\n");
	for(var loop=0;loop<howmany;loop++)
	{
		fGotoScrollPackDown();
		fClick(); 
		fPause(2);  // long client pause
	}
}

//
//fScrollPackUp v1.0
//Parameters: Optional: howmany - how many times to scroll the pack up. Defaults to 1 if you don't give it a parameter.
//Return Value: null
//
function fScrollPackUp(howmany)
{
	if(!howmany)
	{
		howmany=1;// default to one time if no parameter specified.
	}
	if(howmany <1) 
	{
		ac.Print("Error! fScrollPackUp called with " + howmany + " as a parameter, which is not within it's acceptable range.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fScrollPackUp called to scroll pack up " + howmany + " times.\n");
	for(var loop=0;loop<howmany;loop++)
	{
		fGotoScrollPackUp();
		fPause();
		fClick(); // left click the mouse
		fPause();
	}
}

//
//fRandom v1.0
//Parameters: Upper limit
//Return Value: Random number between 1 and the upper limit
//
function fRandom(max)
{
	fScriptLibDebug("fRandom called with " + max + " as a parameter.\n");
	if(isNaN(max))
	{
		ac.Print("Error! " + max + " is not a number! Returning 0.\n");
		fScriptLibDebug("Error! " + max + " is not a number! Returning 0.\n");
		return 0;
	}
	return Math.abs(Math.ceil(Math.random()*max));
}

//
//fGotoMerchantItems v1.2
//Parameters: -Takes which shortcut as a parameter (valid range is 1-?, the max varies. No check on it.)
//Return Value: null
//
function fGotoMerchantItems(which)
{
	if(which<1)
	{
		ac.Print("Error! fGotoMerchantItems called with " + which + ", which is outside it's allowed range of 1+.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoMerchantItems called to go to location " + which + ".\n");
	which--; // accounts for the fact that I wish to specify location as 1-?, not 0-?.
	var myX=(20 + (which * 32));
	var myY=(Height - 130);
	fMouseMoveTo(myX,myY);
}

//
//fGotoMerchantList v1.2
//Parameters: Takes which shortcut as a parameter (valid range is 1-?, the max varies. No check on it.)
//Return Value: null
//
function fGotoMerchantList(which)
{
	if(which<1)
	{
		ac.Print("Error! fGotoMerchantList called with " + which + ", which is outside it's allowed range of 1+.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoMerchantList called to go to dropdown option " + which + ".\n");
	which--; // accounts for the fact that I wish to specify list as 1-?, not 0-?.
	var myX=50;
	var myY=(Height - 152 + (which * 18));
	fMouseMoveTo(myX,myY);
}

//
//fGotoMerchantThreeTabs v1.0
//Parameters: Takes which shortcut as a parameter (valid range is 1-3)
//Return Value: null
//
function fGotoMerchantThreeTabs(which)
{
	if(which<1 || which >3)
	{
		ac.Print("Error! fGotoMerchantThreeTabs called with " + which + ", which is outside the acceptable range of 1-3.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoMerchantThreeTabs called to go to tab " + which + ".\n");
	which--; // accounts for the fact that I wish to specify tabs as 1-3, not 0-2.
	
	var myX=(45 + (which * 90));
	var myY=(Height - 200);
	fMouseMoveTo(myX,myY);
}

//
//fGotoMerchantTriangle v1.1
//Parameters: null
//Return Value: null
//
function fGotoMerchantTriangle()
{
	fScriptLibDebug("fGotoMerchantTriangle called to go to merchant triangle.\n");
	var myX=113;
	var myY=(Height - 175);
	fMouseMoveTo(myX,myY);
}
//fGotoMerchantDown v0.1
//Parameters: null
//Return Value: null - Karl
//
function fGotoMerchantDown()
{
	fScriptLibDebug("fGotoMerchantTriangle called to go to merchant triangle.\n");
	var myX=113;
	var myY=(Height - 30);
	fMouseMoveTo(myX,myY);
}

//fGotoMerchantUp v0.1
//Parameters: null
//Return Value: null - Karl
//
function fGotoMerchantUp()
{
	fScriptLibDebug("fGotoMerchantTriangle called to go to merchant triangle.\n");
	var myX=113;
	var myY=(Height - 150);
	fMouseMoveTo(myX,myY);
}

//
//fSelectObject v1.2
//Parameters: Object Id
//Return Value: null
//
function fSelectObject(objectid)
{
	fScriptLibDebug("fSelectObject called with " + objectid + " to select.\n"); 
	ac.SetPreviousSelectedObject(objectid);
	ac.KeyEvent(g_kb_PreviousSelection);
}

//
//fCastSpell v1.0
//Parameters: level,spell,tab
//Return Value: null
//
function fCastSpell(level,spell,tab)
{
	// We'll leave the error checking to the goto routines
	if (!level)
	{
		level = 1;	// default to level 1 - 1 second pause
	}

	fScriptLibDebug("fCastSpell called with level " + level + ", spell " + spell + ", tab " + tab + ".\n");
	if (tab)
	{
		fGotoSpellTab(tab);
		fClick();
		fPause();
	}

	if (spell)
	{
		fGotoSpell(spell);
		fClick();
		fPause();
	}
	
	fGotoCastSpell();
	fClick();
	fSleepSeconds(level+1);	// sleep one second per level
}

//
//fGotoCreateSpellButtons v1.0
//Parameters: Takes which shortcut as a parameter (valid range is 1-2)
//Return Value: null
//
function fGotoCreateSpellButtons(which)
{
    if(which<1 || which >2)
    {
        ac.Print("Error! fGotoCreateSpellButtons called with " + 
                     which + ", which is outside the acceptable range of 1-2.\n");
        return ciErrorRange;
    }

    fScriptLibDebug("fGotoCreateSpellButtons called to go to shortcut " + which + ".\n");
    
    which--; // accounts for the fact that I wish to specify shortcuts as 1-2, not 0-1.
        
    var myX=(Width - 223 + (which * 150));
    var myY=(Height - 120);
    fMouseMoveTo(myX,myY);
}

//
//fGotoCreateSpellComponents v1.0
//Parameters: Which spell comp shortcut to go to, 1-8 x 1-6
//Return Value: null
//
function fGotoCreateSpellComponents(whichCol, whichRow)
{
    if(whichRow<1 || whichRow >6)
    {
        ac.Print("Error! fGotoCreateSpellComponents called with row " + 
                     whichRow + ", which is outside the acceptable range of 1-8.\n");
        return ciErrorRange;
    }

    if(whichCol<1 || whichCol >8)
    {
        ac.Print("Error! fGotoCreateSpellComponents called with column " + 
                     whichCol + ", which is outside the acceptable range of 1-6.\n");
        return ciErrorRange;
    }

    fScriptLibDebug("fGotoCreateSpellComponents called with " + whichCol + ", " + whichRow + ".\n");

    whichRow--; // accounts for the fact that I wish to specify shortcuts as 1-8 and 1-6, not 0-7 and 0-2.
    whichCol--;
        
    var myX=(Width - 271 + (whichCol * 32));
    var myY=(Height - 327 + (whichRow * 32));

    fMouseMoveTo(myX,myY);
}

//
//fGotoCreateSpellFormula v1.0
//Parameters: -Takes which shortcut as a parameter (valid range is 1-8)
//Return Value: null
//
function fGotoCreateSpellFormula(which)
{
    if(which<1 || which >8)
    {
        ac.Print("Error! fGotoCreateSpellFormula called with " + 
                     which + ", which is outside the acceptable range of 1-8.\n");
        return ciErrorRange;
    }

    fScriptLibDebug("fGotoCreateSpellFormula called to go to shortcut " + which + ".\n");
    
    which--; // accounts for the fact that I wish to specify shortcuts as 1-3, not 0-2.
        
    var myX=(Width - 261 + (which * 32));
    var myY=(Height - 387);
    fMouseMoveTo(myX,myY);
}

//
//fGotoCreateSpellScrollBar v1.0
//Parameters: Takes which shortcut as a parameter (valid range is 1-2)
//Return Value: null
//
function fGotoCreateSpellScrollBar(which)
{
    if(which<1 || which >2)
    {
        ac.Print("Error! fGotoCreateSpellScrollBar called with " + 
                     which + ", which is outside the acceptable range of 1-2.\n");
        return ciErrorRange;
    }
    fScriptLibDebug("fGotoCreateSpellScrollBar called to go to shortcut " + which + ".\n");
    
    which--; // accounts for the fact that I wish to specify shortcuts as 1-2, not 0-1.
        
    var myX=(Width - 23);
    var myY=(Height - 330 + (which * 172));

    fMouseMoveTo(myX,myY);
}

//
//fGotoScrollCompsDown v1.0
//Parameters: null
//Return Value: null
//
function fGotoScrollCompsDown()
{
    var x = (Width - 23);
    var y = (Height - 161);
    fMouseMoveTo(x, y);
}

//
//fGotoScrollCompsUp v1.0
//Parameters: null
//Return Value: null
//
function fGotoScrollCompsUp()
{
    var x = (Width - 23);
    var y = (Height - 335);
    fMouseMoveTo(x, y);
}

//
//fGotoSpell v1.0
//Parameters: Which spell to cast between 1 and 19
//Return Value: 0 on success or 1 on parameter error.
//
function fGotoSpell(iSpell)
{
	if (iSpell<1 || iSpell>19)
	{
		ac.Print("Error! fGotoSpell with [" + iSpell + "], which is outside of the acceptable range of 1-19.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoSpell called to go to Spell " + iSpell + ".\n");
	
	var myX = 70 + (32 * (iSpell - 1));
	var myY = Height - 155;
	
	fMouseMoveTo(myX, myY);
	fClick();
}

//
//fGotoSpellbookTabs v1.0
//Parameters: Which spellbook shortcut tab to go to
//Return Value: null
//
function fGotoSpellbookTabs(which)
{
    if(which<1 || which >3)
    {
        ac.Print("Error! fGotoSpellbookTabs called with " + 
                     which + ", which is outside the acceptable range of 1-3.\n");
        return ciErrorRange;
    }

    fScriptLibDebug("fGotoSpellbookTabs called to go to shortcut " + which + ".\n");
    
    which--; // accounts for the fact that I wish to specify shortcuts as 1-3, not 0-2.
        
    var myX=(Width - 255 + (which * 95));
    var myY=(Height - 439);
    fMouseMoveTo(myX,myY);
}

//
//fGotoSpellComp v1.0
//Parameters: Index number of which spell component number to go to.
//Return Value: null
//
function fGotoSpellComp(index)
{    
	var row = parseInt(index / 8);
	var col = index % 8;
	
	// figure out if we need to scroll up or down
	if( row < g_compsScroll )    
	{
	        while( row < g_compsScroll ) 
	        {            
	        	fScrollCompsUp();                    
	        	fPause();        
	        }    
	}    
	else if( row > g_compsScroll + 5 )
	{        
		while( row > g_compsScroll + 5 )
		{            
			fScrollCompsDown();
			fPause();
		}    
	}    
	var absrow = row - g_compsScroll;
	
	fGotoCreateSpellComponents(col + 1, absrow + 1);
	fPause();
}

//
//fGotoSpellSlot v1.3
//Parameters: Which spell slot you want to move the mouse to, starting with 1.
//Return Value: null
//
function fGotoSpellSlot(which) 
{
	if(which<1) // if the parameter is less than 1 or missing:
	{
		ac.Print("Error! fGotoSpellSlot called with " + which + ", which is outside it's allowed range of 1+.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fGotoSpellSlot called with " + which + " as a parameter.\n");
	if(ciWandHasSpell)
	{
		which++; // adjust for the math to work out.  Math starts with 0 people start with 1.
	}
	var myX=(38+(which*32));
	var myY=(Height-154);
	fMouseMoveTo(myX,myY);
}

//
//fGotoSpellTab v1.1
//Parameters: 1-5 - the spellbar tab you which to select
//Return Value: null
//
function fGotoSpellTab(which) // 5
{
	if(which<1 || which >5) // if the parameter is less than 1, more than 5, or missing:
	{
		ac.Print("Error! fGotoSpellTab called with " + which + ", which is outside it's allowed range of 1-5.\n");
		return ciErrorRange;
	}
	
	fScriptLibDebug("fGotoSpellTab called with " + which + " as a parameter.\n");
	
	which--; // 4 this lets you say fGotoSpellTab(1) and have it not add 70 to 770, which would be spell tab II.
	var myX=(30+(which*70)); // this stays constant from the left hand side of the screen.
	var myY=(Height-190);
	fMouseMoveTo(myX,myY);
}

//
//fResetCreateSpellPage v1.0
//Parameters: null
//Return Value: null
//
function fResetCreateSpellPage()
{
	for(i=0; i<4; i++)
	{
		fScrollCompsUp();
		fPause();
	}
	fGotoCreateSpellButtons(2)
	fClick();
	fPause();
}

//
//fScrollCompsDown v1.0
//Parameters: null
//Return Value: null
//
function fScrollCompsDown()
{
    fGotoScrollCompsDown();
    fClick();
    g_compsScroll++;
}

//
//fScrollCompsUp v1.0
//Parameters: null
//Return Value: null
//
function fScrollCompsUp()
{
    fGotoScrollCompsUp();
    fClick();
    if( g_compsScroll > 0 )
        g_compsScroll--;
}

//
//fCountDown v1.0
//Parameters: Number of seconds to count down from
//Return Value: null
//
function fCountDown(myseconds)
{
	fScriptLibDebug("fCountDown called with " + myseconds + " as a parameter.\n");
	if(!myseconds)
	{
		ac.Print("Error - fCountDown called with [" + myseconds + "] as a parameter. This is invalid. Aborting.");
		return ciErrorRange;
	}
	for(var loop=myseconds;loop>0;loop--)
	{
		fSleep(1000);
		ac.Print(loop + "\n");
	}
}

//
//fPause v1.0
//Parameters: Optional: Pause multiplier: Multiplies what you give it by the value of acslPauseMS.
//Return Value: null
//
function fPause(multiplier)
{
	if(!multiplier)
	{
		multiplier=1;
	}
	fScriptLibDebug("fPause called, calling fSleep with " + acslPauseMS + " * " + multiplier + " as a parameter.\n");
	fSleep(acslPauseMS * multiplier);
}

//
//fResetSleep v1.0
//Parameters: null
//Return Value: null
//
function fResetSleep()
{
	fScriptLibDebug("fResetSleep called.\n");
	mySleepTime = 0;
}

//
//fServerPause v1.0
//Parameters: Optional: Multiplier for longer pauses
//Return Value: null
//
function fServerPause(multiplier)
{
	if(!multiplier)
	{
		multiplier=1;
	}
	if(multiplier<1)
	{
		ac.Print("Error: fServerPause called with " + multiplier + " as the parameter, which is outside the acceptable range of 1+.\n");
		return(ciErrorRange);
	}
	fScriptLibDebug("fServerPause called, calling fSleep with " + acslServerPause + " * " + multiplier + " as a parameter.\n");
	fSleep(acslServerPause * multiplier);
}

//
//fSleep v1.0
//Parameters: Number of ms you want to wait
//Return Value: null
//
function fSleep(time)
{
	fScriptLibDebug("fSleep called with " + time + " as a parameter.\n");
	mySleepTime += time; 
	ac.Sleep(time);
}

//
//fSleepSeconds v1.0
//Parameters: null
//Return Value: null
//
function fSleepSeconds(time)
{
	fScriptLibDebug("fSleepSeconds called with " + time + " as a parameter.\n");
	fSleep( time * 1000);
}

//
//fSleepUntil v1.0
//Parameters: Time in ms to countdown from.
//Return Value: null
//
function fSleepUntil(time)
{
	fScriptLibDebug("fSleepUntil called with " + time + " as the parameter where the current time to countdown from is " + mySleepTime + "\n");
	
	sleep_time = time - mySleepTime;
	if( sleep_time < 250 )
	{
		sleep_time = 250 ; 
	}
	
	fSleep(sleep_time) ; 
}

//
//fCleanUp v1.1
//Parameters: pack,howmany - which pack to drop to and how many
//Return Value: null
//
function fCleanUp(pack,howmany)
{
	if( !pack )
    	{
        	ac.Print("Error fCleanUp: pack out of range (Acceptable range is 2-8)\n");
        	return ciErrorRange;
    	}
	if (!howmany) howmany=112; // default to 102 items with 10 overage (this will get smarter later)

	fScriptLibDebug("fCleanUp executing putting " + howmany + " items into pack # " + pack + ".\n");

	// Since fPutInPack will catch a bogus pack number and quantity, we don't check it here
	fOpenPack(1);
	fPutInPack(pack,howmany);
}

//
//fCombatMode v1.0
//Parameters: null
//Return Value: null
//
function fCombatMode()
{
	fScriptLibDebug("fCombatMode called.\n");

	fPeaceMode();
	fTogglePeaceMode();
}

//
//fCreateFellowship v1.0
//Parameters: Name of the fellowship to create
//Return Value: null
//
function fCreateFellowship(name)
{
	fScriptLibDebug("fCreateFellowship called with " + name + " as a parameter.\n");
	fOpenSocialPanel(); 
	fUseSocialTab(2);
	fNameFellowship(name);
	fGotoFellowshipCreate();
	fClick();
	fServerPause();
}

//
//fDisbandFellowship v1.0
//Parameters: null
//Return Value: null
//
function fDisbandFellowship()
{
	fScriptLibDebug("fDisbandFellowship called.\n");
	fOpenSocialPanel();
	fUseSocialTab(2); 
	fGotoDisbandFellowship();
	fClick();
	fServerPause();
}

//
//fExamine v1.0
//Parameters: null
//Return Value: null
//
function fExamine()
{
	fScriptLibDebug("fExamine called\n");
	fGotoExamine();
	fClick();
	fServerPause();
}

//
//fFromPackToPack v1.0
//Parameters: frompack,topack
//Return Value: null
//
function fFromPackToPack(frompack,topack)
{
	fScriptLibDebug("fFromPackToPack called from pack " + frompack + " to pack " + topack + "\n");
	fOpenPack(frompack);
	fGotoPackSlot(1,1);
	fPutXinPack(topack);
}

//
//fFullJump v1.2
//Parameters: null
//Return Value: null
//
function fFullJump()
{
	fScriptLibDebug("fFullJump called.\n");
	ac.KeyPress(g_kb_Jump);  
	fSleepSeconds(3);
	ac.KeyRelease(g_kb_Jump);
	fSleepSeconds(3);  // Newton's Law
}

//
//fGotoPeaceMode v1.0
//Parameters: null
//Return Value: null
//
function fGotoPeaceMode()
{
	fScriptLibDebug("fGotoPeaceMode called.\n");
	var myX=(Width - 280);
	var myY=(Height - 58);
	fMouseMoveTo(myX,myY);
}

//
//fGotoRaiseChatWindow v1.0
//Parameters: null
//Return Value: null
//
function fGotoRaiseChatWindow()
{
	fScriptLibDebug("fGotoRaiseChatWindow called to raise chat window to half-screen.\n");
	var myX=(Width - 316);
	var myY=(Height - 81);
	fMouseMoveTo(myX,myY);
}

//
//fLieDown v1.2
//Parameters: howlong - how long to lie down for (indefinite if not provided)
//Return Value: null
//
function fLieDown(howlong)
{
	if (!howlong)
	{
		howlong = 0;  // so it's not undefined
	}
	
	fScriptLibDebug("fLieDown called for " + howlong + " seconds.\n");

	ac.KeyEvent(g_kb_Sleeping);
	
	acsl_standup_state=false;
	
	fSleepSeconds(3); // sleep instead of ac.waitevent because you're going to complete the animation anyway.
	
	if (howlong)
	{
		fSleepSeconds(howlong-2);
		fStandUp();
	}
}

//
//fLoginCharacter v1.3
//Parameters: Which slot to login as (1-5) and optionally how long to wait for it to finish.
//Return Value: ciErrorSuccess, or ciErrorNoConnection
//
function fLoginCharacter(charNumber, timeoutSeconds)
{
	fScriptLibDebug("fLoginCharacter called with [" + charNumber + "], [" + timeoutSeconds + "] as parameters.\n");
	
	if( charNumber < 1 || charNumber > 5 )
   	{
       	ac.Print("Error fLoginCharacter: character [" + charNumber + "]out of range (Acceptable range is 1-5)\n");
       	return ciErrorRange;
   	}

	// Do the actual login:
	charNumber--; // the slot math is 0 based but humans start counting at 1.
	var xOffset = 130;
   	var yOffset = 140;
   	yOffset += (charNumber * 17);
   	fMouseMoveTo(xOffset, yOffset);
   	fPause();
   	fDoubleClick(); // <- this starts the login

	// Detect whether or not ACCOM is running AND if we've been supplied with a timeout value.
	if(ac.ConnectedToAC && timeoutSeconds)
	{
   		fScriptLibDebug("fLoginCharacter detected ACCOM is running - using 'smarter' code to wait ["+ timeoutSeconds + "] seconds for login to complete...\n");
   		ac.WaitEvent(3000,ciWaitModeUntilTimeout);
    		
   		var waitCount = 0; 
 
		while (ac.ConnectedToAC < 8 && waitCount<timeoutSeconds)
		{
			ac.Print(" .");
			ac.WaitEvent(1000, ciWaitModeUntilTimeout);
			waitCount++; 
		}
		
		ac.Print("\n"); // ends the line with the dots...
			
    		if(Inventory.Initialized)
    		{
	    		fScriptLibDebug("fLoginCharacter reporting login successful - Inventory.Initialized = [" + Inventory.Initialized + "].\n");
    			return ciErrorSuccess;
    		}
	    	else
	    	{
		    	fScriptLibDebug("fLoginCharacter reporting login failed after waiting [" + timeoutSeconds + "] seconds - Inventory.Initialized = [" + Inventory.Initialized + "].\n");
	    		return ciErrorNoConnection;
	    	}
	}
	else
	{
		if(!timeoutSeconds && ac.ConnectedToAC)  // if we're connected to AC but didn't get a timeout value...
		{
			fScriptLibDebug("fLoginCharacter wasn't given a timeout parameter and\n");
			fScriptLibDebug(" is assuming the calling script will handle checking the inventory.\n");
		}
		if(!ac.ConnectedToAC)
		{
			fScriptLibDebug("fLoginCharacter didn't detect ACCOM - logging in and hoping it works...\n");
		}
		return ciErrorSuccess;
    }		 
}

//
//fLogoutCharacter v1.0
//Parameters: null
//Return Value: null
//
function fLogoutCharacter()
{
    fScriptLibDebug("fLogoutCharacter called\n");
    ac.KeyEvent("~{ESC}");
}

//
//fMakeShortCut v1.1
//Parameters: Which pack, which row and column in the pack, and which shortcut to place it in.
//Return Value: null
//
function fMakeShortCut(iPack, iRow, iCol, iShortCut)
{
	if(fGotoPackSlotAbs(iPack, iCol, iRow) == ciErrorRange)
	{
 		ac.Print("Error: fMakeShortCut called with the following parameters: " + iPack + ", " + iRow + ", " + iCol + ", " + iShortCut + ".\nThe acceptable ranges for these parameters are 1-8, 1-6, 1-3, 1-9.\n");
 		return ciErrorRange;
	}
	
	fScriptLibDebug("fMakeShortCut called with these parameters: " + iPack + ", " + iRow + ", " + iCol + ", " + iShortCut + "\n");
 		
	ac.MouseButtonPress(ciMouseButton_Left);
	fPause();
	
	if(fGotoShortcut(iShortCut) == ciErrorRange)
	{
		ac.MouseButtonRelease(ciMouseButton_Left);
		return ciErrorRange;
	}
 
	fPause();
	ac.MouseButtonRelease(ciMouseButton_Left);
	fPause();
}

//
//fNameFellowship v1.0
//Parameters: Name of the fellowship to create
//Return Value: null
//
function fNameFellowship(name)
{
	fScriptLibDebug("fFellowshipName called with " + name + " as a parameter.\n");
	fGotoFellowshipName();
	fClick();
	fServerPause();
	ac.KeyPaste(name);
	fServerPause();
}

//
//fOpenAttributes v1.1
//Parameters: null
//Return Value: null
//
function fOpenAttributes()
{
	fScriptLibDebug("fOpenAttributes called\n");
	ac.KeyEvent(g_kb_SkillsPanel);	// just in case we're already there
	ac.KeyEvent(g_kb_AttributesPanel);
}

//
//fOpenMap v1.1
//Parameters: null
//Return Value: null
//
function fOpenMap()
{
	fScriptLibDebug("fOpenMap called\n");
	ac.KeyEvent(g_kb_AttributesPanel);	// just in case we're already there
	ac.KeyEvent(g_kb_MapPanel);
}

//
//fOpenSkills v1.2
//Parameters: null
//Return Value: null
//
function fOpenSkills()
{
	fScriptLibDebug("fOpenSkills called\n");
	ac.KeyEvent(g_kb_AttributesPanel); 
	ac.KeyEvent(g_kb_SkillsPanel); 
}

//
//fPeaceMode v1.2
//Parameters: null
//Return Value: null
//
function fPeaceMode()
{
	fScriptLibDebug("fPeaceMode called.\n");
	if(ac.ConnectedToAC)
	{
		fScriptLibDebug("fPeaceMode using ACCom to determine combat state - ac.ConnectedToAC == " + ac.ConnectedToAC + "\n");
		if(ac.InCombatMode)
		{
			fScriptLibDebug("fPeaceMode detected that the character is in combat mode.\n");
			fTogglePeaceMode();
		}
		else
		{
			fScriptLibDebug("fPeaceMode detected that the character is already in Peace Mode - returning.\n");
			return;
		}
	}
	else
	{
		fScriptLibDebug("fPeaceMode didn't detect ACCom/an AC connection. (ac.ConnectedToAC ==  " +  ac.ConnectedToAC + "). Using 'bowless bow dance' to ensure Peace Mode\n");
		ac.KeyEvent(g_kb_PointState);
		fServerPause();
		fTogglePeaceMode();
		ac.KeyEvent(g_kb_Ready);
		fServerPause();
	}
}

//
//fRelease v1.0
//Parameters: null
//Return Value: null
//
function fRelease()
{
	fScriptLibDebug("fRelease called\n");

	ac.MouseButtonRelease(ciMouseButton_Left);
	fPause();
}

//
//fRemoveAllJewelry v1.0
//Parameters: pack - which pack to move them to.  Default is the backpack.
//Return Value: null
//
function fRemoveAllJewelry(pack)
{
	if (!pack) pack = 1; // default to putting it in the backpack
	fScriptLibDebug("fRemoveAllJewelry called - moving to pack " + pack + ".\n");

	fOpenInventory();

	fGotoNecklace();
	fPutXinPack(pack);
	
	fGotoRing(ciRing_Left);
	fPutXinPack(pack);

	fGotoRing(ciRing_Right);
	fPutXinPack(pack);

	fGotoBracelet(ciBracelet_Left);
	fPutXinPack(pack);

	fGotoBracelet(ciBracelet_Right);
	fPutXinPack( pack );
}

//
//fSelect v1.0
//Parameters: null
//Return Value: null
//
function fSelect()
{
	fScriptLibDebug("fSelect called\n");

	fClick();
	fPause();
}

//
//fSelectFirst v1.0
//Parameters: null
//Return Value: null
//
function fSelectFirst()
{
	fScriptLibDebug("fSelectFirst called\n");

	fGotoPackSlot(1,1);
	fSelect();
}

//
//fSelectShortcut v1.0
//Parameters: Which shortcut
//Return Value: null
//
function fSelectShortcut(shortcut)
{
	fScriptLibDebug("fSelectShortcut called with " + shortcut + " as a parameter.\n");
	if(shortcut<1 || shortcut >9)
	{
		fScriptLibDebug("fSelectShortcut ERROR, invalid parameter passed.\n");
	}
	// the following is similar to opening the skills page before opening the inventory window. 
	// it makes sure that we didn't already have what we wanted, clicked. 
	if(shortcut==9)
	{
		fGotoShortcut(8);
		fClick();
		fPause();
	}
	else
	{
		fGotoShortcut(9);
		fClick();
		fPause();
	}
	fGotoShortcut(shortcut);
	fClick();
	fPause();
}

//
//fSpin v1.1
//Parameters: null
//Return Value: null
//
function fSpin()
{	
	fScriptLibDebug("fSpin called.\n");
	ac.KeyPress(g_kb_TurnRight);
	fSleepSeconds(2);
	ac.KeyRelease(g_kb_TurnRight);
}

//
//fStandUp v1.2
//Parameters: null
//Return Value: null
//
function fStandUp()
{
	fScriptLibDebug("fStandUp called.\n");
	ac.KeyEvent(g_kb_Ready);
	acsl_standup_state=true;
	fSleepSeconds(3);  // standing up takes a while if you're on your back
}

//
//fSuicide v1.0
//Parameters: null
//Return Value: null
//
function fSuicide()
{
	fSay("@lifestone");
	fPause();
	ac.KeyEvent("y");
}

//
//fTapJump v1.2
//Parameters: null
//Return Value: null
//
function fTapJump()
{
	fScriptLibDebug("fTapJump called.\n");
	ac.KeyPress(g_kb_Jump);  
	ac.KeyRelease(g_kb_Jump);
	fPause();
}

//
//fTogglePeaceMode v1.0
//Parameters: null
//Return Value: null
//
function fTogglePeaceMode( )
{
	fScriptLibDebug("fTogglePeaceMode called.\n");

	fGotoPeaceMode();
	fClick();
	fServerPause(2);  // Need a long delay here for the animation
}

//
//fUseShortcut v1.0
//Parameters: Which shortcut
//Return Value: null
//
function fUseShortcut(iShortCut)
{
	if(iShortCut<1 || iShortCut >9)
	{
		ac.Print("Error: fUseShortcut called wtih " + iShortCut + " which is outside the allowable range of 1-9.\n");
		return ciErrorRange;
	}
	fScriptLibDebug("fUseShortcut called with " + iShortCut + " as a parameter\n");
	fGotoShortcut(iShortCut); // hit the shortcut key
	fPause();
	fDoubleClick();
	fPause();
}

//
//fUseSocialTab v1.0
//Parameters: Which tab to hit (1-3)
//Return Value: null
//
function fUseSocialTab(which)
{
	fScriptLibDebug("fUseSocialTab called with " + which + " as a parameter.\n");
	if(which >3 || which <1)
	{
		ac.Print("Error: fSocialTab called with the parameter " + which + " which is out of the acceptable range of 1 and 3\n");
		return ciErrorRange;
	}
	fGotoSocialTab(which);
	fClick();
	fServerPause();
}

function sSay(text)
{
	skapi.OutputLine(text,opmChatWnd)
}
